<template>
	<section id="card" class="flex flex-col mt-24 mb-24">
		<div v-if="!onUpdate" class="mb-12 h-full max-w-4xl m-auto container flex justify-between items-center">
			<div class="block w-1/2">
				<p class="mb-10 text-4xl font-light">{{dataCard.name}}</p>
				<div class="image block w-64 h-64">
					<img class="h-full" :src="`static/upload/${dataCard.image}`"
					     :alt="`Image de la carte ${dataCard.name}`">
				</div>
				<button v-if="isAdmin" @click="updateCard"
				        class="bg-red-600 hover:bg-red-700 text-white font-bold py-2 px-4 rounded mt-8 inline-block text-center cursor-pointer transition duration-500 ease">
					Modifier
				</button>
				<button v-if="isAdmin" @click="deleteCard"
				        class="bg-red-600 hover:bg-red-700 text-white font-bold py-2 px-4 rounded mt-8 inline-block text-center cursor-pointer transition duration-500 ease">
					Supprimer
				</button>
			</div>
			<div class="w-1/2 font-light">
				<p class="mb-5">Numéro de série : {{dataCard.key}}</p>
				<p class="mb-5">Quantité : {{dataCard.amount}}</p>
				<p class="italic">{{dataCard.description}}</p>
			</div>
		</div>
		<!-- Handle message error -->
		<div v-if="error !== null && !onUpdate"
		     class="m-auto bg-red-100 border border-red-400 text-red-700 px-4 py-3 rounded relative" role="alert">
			<strong class="font-bold">Une erreur est survenue!</strong>
			<span class="block sm:inline">{{error}}</span>
		</div>
		<div v-if="onUpdate">
			<h1 class="mb-5 w-2/4 m-auto text-3xl text-center">Modifier la carte</h1>
			<form @submit="submitForm" class="bg-white shadow-md rounded px-8 pt-6 pb-8 mb-12 w-2/4 m-auto">
				<div class="mb-4">
					<label class="block text-sm font-bold mb-2" for="name">
						Nom
					</label>
					<input class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 leading-tight focus:outline-none focus:shadow-outline"
					       id="name"
					       name="name"
					       type="text"
					       v-model="dataForm.name"
					       placeholder="Nom de la carte"
					       required>
				</div>
				<div class="mb-4">
					<label class="block text-sm font-bold mb-2" for="key">
						Référence
					</label>
					<input class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 mb-3 leading-tight focus:outline-none focus:shadow-outline"
					       id="key"
					       name="key"
					       type="text"
					       v-model="dataForm.key"
					       placeholder="WSUP-FR010"
					       required>
				</div>
				<div class="mb-4">
					<label class="block text-sm font-bold mb-2" for="description">
						Description
					</label>
					<input class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 leading-tight focus:outline-none focus:shadow-outline"
					       id="description"
					       name="description"
					       type="text"
					       v-model="dataForm.description"
					       placeholder="Description de la carte"
					       required>
				</div>
				<div class="mb-4">
					<label class="block text-sm font-bold mb-2" for="amount">
						Quantité
					</label>
					<input class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 leading-tight focus:outline-none focus:shadow-outline"
					       id="amount"
					       name="amount"
					       type="number"
					       v-model.number="dataForm.amount"
					       placeholder="Quantité"
					       min="1"
					       required>
				</div>
				<div class="flex items-center justify-between">
					<button class="bg-red-600 hover:bg-red-700 text-white font-bold py-2 px-4 rounded focus:outline-none focus:shadow-outline"
					        type="submit">
						Valider
					</button>
					<button @click="onUpdate = false"
					        class="bg-red-600 hover:bg-red-700 text-white font-bold py-2 px-4 rounded focus:outline-none focus:shadow-outline"
					        type="button">
						Annuler
					</button>
				</div>
				<!-- Handle message error -->
				<div v-if="error !== null"
				     class="mt-6 bg-red-100 border border-red-400 text-red-700 px-4 py-3 rounded relative" role="alert">
					<strong class="font-bold">Une erreur est survenue!</strong>
					<span class="block sm:inline">{{error}}</span>
				</div>
			</form>
		</div>
	</section>
</template>

<script>
	import ApiService from '../services/ApiService'
	import {mapGetters} from 'vuex'

	export default {
		data () {
			return {
				dataCard: {},
				onUpdate: false,
				error: null,
				dataForm: {},
			}
		},
		computed: {
			...mapGetters([
				'token',
				'isAdmin',
			])
		},
		methods: {
			deleteCard: async function () {
				this.error = null

				try {
					await ApiService.request({
						url: `/cards/${this.id}`,
						method: 'delete',
						headers: {Authorization: `Bearer ${this.token}`},
					})

					return this.$router.push('/')
				} catch (e) {
					this.error = 'Veuillez réessayer plus tard.'
				}
			},
			updateCard: function () {
				this.onUpdate = true
				this.dataForm = Object.assign({}, this.dataCard)
			},
			async submitForm (e) {
				e.preventDefault()

				this.error = null

				const data = new FormData()

				const blackList = ['_id', 'added_by']

				for (const key in this.dataForm) {
					if (this.dataForm.hasOwnProperty(key) && !blackList.includes(key)) {
						data.append(key, this.dataForm[key])
					}
				}

				try {
					await ApiService.request({
						url: `/cards/${this.id}`,
						method: 'put',
						headers: {Authorization: `Bearer ${this.token}`},
						data
					})

					data.forEach((value, key) => {
						if (this.dataCard.hasOwnProperty(key)) {
							this.dataCard[key] = value
						}
					})

					this.onUpdate = false
				} catch (e) {
					this.error = 'Les données saisies sont incorrectes.'
				}
			},
			handleInputFile () {
				this.dataForm.card_image = this.$refs.file.files[0]
			}
		},
		props: ['id'],
		async mounted () {
			this.error = null

			try {
				this.dataCard = await ApiService.request({
					url: `/cards/${this.id}`,
					method: 'get'
				})
			} catch (e) {
				this.dataCard = {}
				this.error = 'Un problème est survenue. Veuillez réessayer plus tard.'
			}
		}
	}
</script>
